"use strict";

const errors = require("../errors");
const getValueType = require("../util/get-value-type");

module.exports = function createUndefinedValidatorFunction(_options = {}) {
	return function validateUndefined(value) {
		if (value !== undefined) {
			return new errors.ValidationError(`Expected undefined, got ${getValueType(value)} instead`);
		} else {
			return true;
		}
	};
};
